 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "karith1.h"
/*-----------------------------------------------------------
| 
|  Routine Name: karith1_get_args
| 
|       Purpose: Gets command line args for karith1
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname karith1
|          Date: Apr 12, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void karith1_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for karith1 is out of sync with arguments specified in karith1's *.pane file; please rerun ghostwriter on karith1.";


	/*
	 * allocate the karith1 structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "abs",
			  &(clui_info->abs_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sin",
			  &(clui_info->sin_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sqrt",
			  &(clui_info->sqrt_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "asin",
			  &(clui_info->asin_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cbrt",
			  &(clui_info->cbrt_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cos",
			  &(clui_info->cos_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "neg",
			  &(clui_info->neg_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "acos",
			  &(clui_info->acos_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "recip",
			  &(clui_info->recip_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tan",
			  &(clui_info->tan_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ceil",
			  &(clui_info->ceil_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "atan",
			  &(clui_info->atan_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "floor",
			  &(clui_info->floor_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sinh",
			  &(clui_info->sinh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "trunc",
			  &(clui_info->trunc_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "asinh",
			  &(clui_info->asinh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "fract",
			  &(clui_info->fract_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cosh",
			  &(clui_info->cosh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "lgamma",
			  &(clui_info->lgamma_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "acosh",
			  &(clui_info->acosh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "erf",
			  &(clui_info->erf_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tanh",
			  &(clui_info->tanh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "erfc",
			  &(clui_info->erfc_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "atanh",
			  &(clui_info->atanh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sinc",
			  &(clui_info->sinc_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "not",
			  &(clui_info->not_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "clear",
			  &(clui_info->clear_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "set",
			  &(clui_info->set_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



