 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "klinearop.h"
/*-----------------------------------------------------------
| 
|  Routine Name: klinearop_get_args
| 
|       Purpose: Gets command line args for klinearop
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname klinearop
|          Date: Apr 13, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void klinearop_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for klinearop is out of sync with arguments specified in klinearop's *.pane file; please rerun ghostwriter on klinearop.";


	/*
	 * allocate the klinearop structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "flip",
			  &(clui_info->flip_logic),
			  &(clui_info->flip_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "upcast",
			  &(clui_info->upcast_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "w0",
			  &(clui_info->w0_int),
			  &(clui_info->w0_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "h0",
			  &(clui_info->h0_int),
			  &(clui_info->h0_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "d0",
			  &(clui_info->d0_int),
			  &(clui_info->d0_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "t0",
			  &(clui_info->t0_int),
			  &(clui_info->t0_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "e0",
			  &(clui_info->e0_int),
			  &(clui_info->e0_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wp",
			  &(clui_info->wp_int),
			  &(clui_info->wp_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ws",
			  &(clui_info->ws_int),
			  &(clui_info->ws_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hp",
			  &(clui_info->hp_int),
			  &(clui_info->hp_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hs",
			  &(clui_info->hs_int),
			  &(clui_info->hs_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dp",
			  &(clui_info->dp_int),
			  &(clui_info->dp_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ds",
			  &(clui_info->ds_int),
			  &(clui_info->ds_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tp",
			  &(clui_info->tp_int),
			  &(clui_info->tp_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ts",
			  &(clui_info->ts_int),
			  &(clui_info->ts_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ep",
			  &(clui_info->ep_int),
			  &(clui_info->ep_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "es",
			  &(clui_info->es_int),
			  &(clui_info->es_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "l",
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "size",
			  &(clui_info->size_logic),
			  &(clui_info->size_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "c",
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



