 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "itexture.h"
/*-----------------------------------------------------------
| 
|  Routine Name: itexture_get_args
| 
|       Purpose: Gets command line args for itexture
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname itexture
|          Date: Apr 11, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void itexture_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for itexture is out of sync with arguments specified in itexture's *.pane file; please rerun ghostwriter on itexture.";


	/*
	 * allocate the itexture structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5L5",
			  &(clui_info->L5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5L5",
			  &(clui_info->E5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5L5",
			  &(clui_info->S5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5L5",
			  &(clui_info->W5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5L5",
			  &(clui_info->R5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5E5",
			  &(clui_info->L5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5E5",
			  &(clui_info->E5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5E5",
			  &(clui_info->S5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5E5",
			  &(clui_info->W5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5E5",
			  &(clui_info->R5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5S5",
			  &(clui_info->L5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5S5",
			  &(clui_info->E5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5S5",
			  &(clui_info->S5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5S5",
			  &(clui_info->W5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5S5",
			  &(clui_info->R5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5W5",
			  &(clui_info->L5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5W5",
			  &(clui_info->E5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5W5",
			  &(clui_info->S5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5W5",
			  &(clui_info->W5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5W5",
			  &(clui_info->R5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5R5",
			  &(clui_info->L5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5R5",
			  &(clui_info->E5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5R5",
			  &(clui_info->S5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5R5",
			  &(clui_info->W5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5R5",
			  &(clui_info->R5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



